/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// to - The sip uri represnting the destination of the call.    identity - The sip uri representing the identity used to make the call, also the caller ID that will be presented to the callee.    sipHeaders - A collection of sipHeader to add or override the default sip headers.    cpaTimeout - If 0, will not perform call progress analysis, if &gt; 0 will perform the call progress analysis for the given value (in milliseconds).    waitForCompletion - If true, the http request will return only when the call is completed (established or failed), if false, the request returns immediately the webhook will be used to determine if the call was connected or not.
    /// </summary>
    [DataContract]
        public partial class MakeCallParams :  IEquatable<MakeCallParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MakeCallParams" /> class.
        /// </summary>
        /// <param name="to">to.</param>
        /// <param name="identity">identity.</param>
        /// <param name="sipHeaders">sipHeaders.</param>
        /// <param name="cpaTimeout">cpaTimeout.</param>
        /// <param name="waitForCompletion">waitForCompletion.</param>
        public MakeCallParams(string to = default(string), string identity = default(string), List<string> sipHeaders = default(List<string>),
            int? cpaTimeout = default(int?), string? userContext = default(string?), bool? waitForCompletion = default(bool?))
        {
            this.To = to;
            this.Identity = identity;
            this.SipHeaders = sipHeaders;
            this.CpaTimeout = cpaTimeout;
            this.UserContext = userContext;
            this.WaitForCompletion = waitForCompletion;
        }
        
        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }

        /// <summary>
        /// Gets or Sets Identity
        /// </summary>
        [DataMember(Name="identity", EmitDefaultValue=false)]
        public string Identity { get; set; }

        /// <summary>
        /// Gets or Sets SipHeaders
        /// </summary>
        [DataMember(Name="sipHeaders", EmitDefaultValue=false)]
        public List<string> SipHeaders { get; set; }

        /// <summary>
        /// Gets or Sets CpaTimeout
        /// </summary>
        [DataMember(Name="cpaTimeout", EmitDefaultValue=false)]
        public int? CpaTimeout { get; set; }

        /// <summary>
        /// Gets or Sets UserContext
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets WaitForCompletion
        /// </summary>
        [DataMember(Name="waitForCompletion", EmitDefaultValue=false)]
        public bool? WaitForCompletion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MakeCallParams {\n");
            sb.Append("  To: ").Append(To).Append("\n");
            sb.Append("  Identity: ").Append(Identity).Append("\n");
            sb.Append("  SipHeaders: ").Append(SipHeaders).Append("\n");
            sb.Append("  CpaTimeout: ").Append(CpaTimeout).Append("\n");
            sb.Append("  UserContext: ").Append(UserContext).Append("\n");
            sb.Append("  WaitForCompletion: ").Append(WaitForCompletion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as MakeCallParams);
        }

        /// <summary>
        /// Returns true if MakeCallParams instances are equal
        /// </summary>
        /// <param name="input">Instance of MakeCallParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MakeCallParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.To == input.To ||
                    (this.To != null &&
                    this.To.Equals(input.To))
                ) && 
                (
                    this.Identity == input.Identity ||
                    (this.Identity != null &&
                    this.Identity.Equals(input.Identity))
                ) && 
                (
                    this.SipHeaders == input.SipHeaders ||
                    this.SipHeaders != null &&
                    input.SipHeaders != null &&
                    this.SipHeaders.SequenceEqual(input.SipHeaders)
                ) && 
                (
                    this.CpaTimeout == input.CpaTimeout ||
                    (this.CpaTimeout != null &&
                    this.CpaTimeout.Equals(input.CpaTimeout))
                ) &&
                (
                    this.UserContext == input.UserContext ||
                    (this.UserContext != null &&
                    this.UserContext.Equals(input.UserContext))
                ) &&
                (
                    this.WaitForCompletion == input.WaitForCompletion ||
                    (this.WaitForCompletion != null &&
                    this.WaitForCompletion.Equals(input.WaitForCompletion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.To != null)
                    hashCode = hashCode * 59 + this.To.GetHashCode();
                if (this.Identity != null)
                    hashCode = hashCode * 59 + this.Identity.GetHashCode();
                if (this.SipHeaders != null)
                    hashCode = hashCode * 59 + this.SipHeaders.GetHashCode();
                if (this.CpaTimeout != null)
                    hashCode = hashCode * 59 + this.CpaTimeout.GetHashCode();
                if (this.UserContext != null)
                    hashCode = hashCode * 59 + this.UserContext.GetHashCode();
                if (this.WaitForCompletion != null)
                    hashCode = hashCode * 59 + this.WaitForCompletion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
